Subject: Re: [PATCH net-next] hyperv: Add handler for RNDIS_STATUS_NETWORK_CHANGE event

From: Richard Weinberger <[email-masked]>
Date: Fri, 30 Oct 2015 23:10:55 +0100

Am 30.10.2015 um 23:03 schrieb Haiyang Zhang:
> 
> 
>> -----Original Message-----
>> From: Vitaly Kuznetsov [mailto:[email-masked]]
>> Sent: Friday, October 30, 2015 6:56 AM
>> To: Haiyang Zhang <[email-masked]>
>> Cc: Richard Weinberger <[email-masked]>; David Miller
>> <[email-masked]>; [email-masked]; [email-masked]; driverdev-
>> [email-masked]; LKML <[email-masked]>;
>> [email-masked]
>> Subject: Re: [PATCH net-next] hyperv: Add handler for
>> RNDIS_STATUS_NETWORK_CHANGE event
>>
>> Haiyang Zhang <[email-masked]> writes:
>>
>>>> -----Original Message-----
>>>> From: Richard Weinberger [mailto:[email-masked]]
>>>> Sent: Tuesday, October 27, 2015 6:36 PM
>>>> To: David Miller <[email-masked]>
>>>> Cc: Haiyang Zhang <[email-masked]>; [email-masked]; Greg
>> Kroah-
>>>> Hartman <[email-masked]>; [email-masked]; [email-masked];
>>>> [email-masked]; LKML <linux-
>>>> [email-masked]>
>>>> Subject: Re: [PATCH net-next] hyperv: Add handler for
>>>> RNDIS_STATUS_NETWORK_CHANGE event
>>>>
>>>> On Mon, Jun 23, 2014 at 10:10 PM, David Miller <[email-masked]>
>>>> wrote:
>>>>> From: Haiyang Zhang <[email-masked]>
>>>>> Date: Mon, 23 Jun 2014 16:09:59 +0000
>>>>>
>>>>>> So, what's the equivalent or similar command to "network restart"
>> on
>>>> SLES12? Could
>>>>>> you update the command line for the usermodehelper when porting
>> this
>>>> patch to SLES
>>>>>> 12?
>>>>>
>>>>> No, you are not going to keep the usermodehelper invocation in your
>>>> driver
>>>>> please remove it.  It is absolutely inappropriate, and I strictly
>> do
>>>> not want
>>>>> to keep it in there because other people will copy it and then
>> we'll
>>>> have a
>>>>> real mess on our hands.
>>>>
>>>> Sorry for digging up this old thread.
>>>> While talking with some guys about usermodehelper abuses I came
>> across
>>>> this gem.
>>>> Mainline still contains that "/etc/init.d/network restart" code.
>>>> Haiyang, care to cleanup?
>>>
>>> Hi Richard and others,
>>>
>>> Thanks for the reminder. I will clean up the usermode helper.
>>>
>>> Do you have suggestions of trigger DHCP refresh from kernel mode? Any
>>> sample code in the existing kernel code?
>>>
>>
>> I think it's wrong to call dhcp refresh from kernel. What happens when
>> we reconnect normal hardware adapter to another network? Link goes down
>> and then up and userspace is supposed to react accordingly. I think we
>> should emulate something similar for RNDIS_STATUS_NETWORK_CHANGE.
> 
> When link is down physically for a few seconds, the DHCP will automatically 
> refresh. I will add code to emulate this. There were some discussions around 
> this and other possibilities previously... I agree emulating what happens 
> with physically plug/unplug a cable is a reasonable way to trigger the DHCP 
> refresh.

Can't you propagate the event to userspace and let it take an appropriate
action?

Thanks,
//richard